## lua-nvim 0.0.1

=== Makefile ===
# This Makefile's only purpose is to simplify creating/maintaining a
# development environment. It will setup a project-private prefix(.deps/usr)
# with all dependencies required for building/testing
#
# local.mk is ignored by git and can be used for developer-specific
# customizations, which can be:
# - override default target
# - define custom targets
# - override ovariables defined here(all variables are defined with ?=)
-include local.mk

# Dependencies prefix
DEPS_DIR ?= $(shell pwd)/.deps
DEPS_PREFIX ?= $(DEPS_DIR)/usr
DEPS_BIN ?= $(DEPS_PREFIX)/bin

# Lua-related configuration
LUA_URL ?= http://www.lua.org/ftp/lua-5.1.5.tar.gz
LUAROCKS_URL ?= https://github.com/keplerproject/luarocks/archive/v2.2.0.tar.gz
LUA_TARGET ?= linux
LUA ?= $(DEPS_BIN)/lua
LUAROCKS ?= $(DEPS_BIN)/luarocks
BUSTED ?= $(DEPS_BIN)/busted
LUV ?= $(DEPS_PREFIX)/lib/luarocks/rocks/luv
MPACK ?= $(DEPS_PREFIX)/lib/luarocks/rocks/mpack
COXPCALL ?= $(DEPS_PREFIX)/lib/luarocks/rocks/coxpcall

# Compilation
CC ?= gcc
CFLAGS ?= -g -fPIC -Wall -Wextra -Werror -Wconversion -Wextra \
	-Wstrict-prototypes -pedantic
LDFLAGS ?= -shared -fPIC
DEPS_INCLUDE_FLAGS ?= -I$(DEPS_PREFIX)/include

# Misc
# Options used by the 'valgrind' target, which runs the tests under valgrind
VALGRIND_OPTS ?= --log-file=valgrind.log --leak-check=yes --track-origins=yes
# Command that will download a file and pipe it's contents to stdout
FETCH ?= curl -L -o -
# Command that will gunzip/untar a file from stdin to the current directory,
# stripping one directory component
UNTGZ ?= tar xfz - --strip-components=1


all: deps nvim/native.so

deps: | $(MPACK) $(COXPCALL) $(BUSTED) $(LUV)

test: all
	$(BUSTED) -v '--lpath=./nvim/?.lua;' '--cpath=./nvim/?.so;' -o gtest test

valgrind: all
	eval $$($(LUAROCKS) path); \
	valgrind $(VALGRIND_OPTS) $(LUA) \
		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc11-0/bin/busted \
		'--lpath=./nvim/?.lua;' '--cpath=./nvim/?.so;' test
	cat valgrind.log

clean:
	rm -f nvim/*.o nvim/*.so

distclean: clean
	rm -rf $(DEPS_DIR)

nvim/native.o: nvim/native.c $(LUA) $(LIBUV)
	$(CC) $(CFLAGS) -o $@ -c $< $(DEPS_INCLUDE_FLAGS)

nvim/native.so: nvim/native.o
	$(CC) $(LDFLAGS) $< -o $@

$(BUSTED): | $(LUAROCKS)
	$(LUAROCKS) install busted
	$(LUAROCKS) install inspect  # helpful for debugging

$(LUV): $(LUAROCKS)
	$(LUAROCKS) install luv

$(MPACK): $(LUAROCKS)
	$(LUAROCKS) install mpack

$(COXPCALL): $(LUAROCKS)
	$(LUAROCKS) install coxpcall

$(LUAROCKS): $(LUA)
	dir="$(DEPS_DIR)/src/luarocks"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUAROCKS_URL) | $(UNTGZ) && \
	./configure --prefix=$(DEPS_PREFIX) --force-config \
		--with-lua=$(DEPS_PREFIX) && make bootstrap

$(LUA):
	dir="$(DEPS_DIR)/src/lua"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUA_URL) | $(UNTGZ) && \
	sed -i -e '/^CFLAGS/s/-O2/-g/' src/Makefile && \
	make $(LUA_TARGET) install INSTALL_TOP=$(DEPS_PREFIX)

.PHONY: all deps test valgrind clean distclean

## lua-nvim 0.0.1-25

=== debian/changelog ===
lua-nvim (0.0.1-25-1) unstable; urgency=medium

  * Initial release (Closes: #832435)

 -- Jason Pleau <jason@jpleau.ca>  Thu, 15 Sep 2016 21:29:46 -0400

=== debian/control ===
Source: lua-nvim
Priority: optional
Maintainer: Jason Pleau <jason@jpleau.ca>
Build-Depends: debhelper (>= 9),
            dh-lua,
            libuv1-dev,
            lua-busted,
            lua-coxpcall,
            lua-luv,
            lua-mpack,
            neovim
Standards-Version: 3.9.8
Section: interpreters
Homepage: https://github.com/neovim/lua-client/
Vcs-Git: https://anonscm.debian.org/cgit/pkg-lua/lua-nvim.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lua/lua-nvim.git

Package: lua-nvim
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         lua-coxpcall,
         lua-mpack,
         lua-luv
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: Lua client for Neovim
 lua-nvim provices a mean to communicate with neovim sessions
 through Lua.

Package: lua-nvim-dev
Section: libdevel
Architecture: any
Depends: lua-nvim (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: Lua client for Neovim
 This package provide the static library for lua-nvim

## lua-nvim 0.0.1-26

=== debian/changelog ===
lua-nvim (0.0.1-26-3) unstable; urgency=medium

  * Update Vcs-* Fields
  * Bump Standards-Version to 4.1.4, no changes needed
  * Bump debhelper compat to 11

 -- Jason Pleau <jason@jpleau.ca>  Mon, 14 May 2018 17:15:26 -0400

lua-nvim (0.0.1-26-2) unstable; urgency=medium

  * Upload to unstable
  * Bump Standards-Version to 4.0.0, no changes needed

 -- Jason Pleau <jason@jpleau.ca>  Sat, 08 Jul 2017 10:28:57 -0400

lua-nvim (0.0.1-26-1) experimental; urgency=medium

  * New upstream release
  * Add libkvm-dev to B-D on kfreebsd

 -- Jason Pleau <jason@jpleau.ca>  Thu, 04 May 2017 21:30:09 -0400

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: lua-nvim
 Priority: optional
 Maintainer: Jason Pleau <jason@jpleau.ca>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11~),
             dh-lua,
             libuv1-dev,
+            libkvm-dev [kfreebsd-any],
             lua-busted,
             lua-coxpcall,
             lua-luv,
             lua-mpack,
             neovim
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Section: interpreters
 Homepage: https://github.com/neovim/lua-client/
-Vcs-Git: https://anonscm.debian.org/cgit/pkg-lua/lua-nvim.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lua/lua-nvim.git
+Vcs-Git: https://salsa.debian.org/lua-team/lua-nvim
+Vcs-Browser: https://salsa.debian.org/lua-team/lua-nvim
 
 Package: lua-nvim
 Architecture: any
@@ -31,7 +32,9 @@
 Package: lua-nvim-dev
 Section: libdevel
 Architecture: any
-Depends: lua-nvim (= ${binary:Version}), ${misc:Depends}
+Depends: lua-nvim (= ${binary:Version}),
+         ${misc:Depends},
+         libkvm-dev [kfreebsd-any]
 Provides: ${lua:Provides}
 XB-Lua-Versions: ${lua:Versions}
 Description: Lua client for Neovim

## lua-nvim 0.1.0-1

=== debian/changelog ===
lua-nvim (0.1.0-1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 06 Aug 2019 11:16:14 -0700

lua-nvim (0.1.0-1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- James McCoy <jamessan@debian.org>  Mon, 18 Jun 2018 21:30:32 -0400

lua-nvim (0.1.0-1-1) unstable; urgency=medium

  * New upstream release
    + Handle stream errors before acting on the stream (Closes: #900650)
    + test: Accept new/old error messages for invalid rpcrequest() syntax

 -- Jason Pleau <jason@jpleau.ca>  Mon, 11 Jun 2018 20:44:29 -0400

lua-nvim (0.0.1-26-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- James McCoy <jamessan@debian.org>  Wed, 23 May 2018 08:15:43 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,8 @@
 Source: lua-nvim
 Priority: optional
-Maintainer: Jason Pleau <jason@jpleau.ca>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Jason Pleau <jason@jpleau.ca>
+Uploaders: James McCoy <jamessan@debian.org>
 Build-Depends: debhelper (>= 11~),
             dh-lua,
             libuv1-dev,

## lua-nvim 0.2.0-1

=== debian/changelog ===
lua-nvim (0.2.0-1-2) unstable; urgency=medium

  * Add allow-stderr restriction to autopkgtest, since latest lua-luv is now
    dumping the error stack to stderr
  * Add myself to Uploaders
  * Use https URL for copyright-format
  * Set Rules-Requires-Root: no
  * Declare compliance with Policy 4.4.1, no changes needed

 -- James McCoy <jamessan@debian.org>  Thu, 31 Oct 2019 23:57:04 -0400

lua-nvim (0.2.0-1-1) unstable; urgency=medium

  * New upstream release
  * Remove patch 0001, merged upstream
  * Replace debhelper B-D with debhelper-compat (= 12), remove d/compat
  * Bump Standards-Version to 4.4.0, no changes were needed

 -- Jason Pleau <jason@jpleau.ca>  Wed, 11 Sep 2019 10:17:13 -0400

lua-nvim (0.1.0-1-2) unstable; urgency=medium

  * New changelog entry
  * Include a patch to fix a FTBFS due to test timeout (Closes: #920042)

 -- Jason Pleau <jason@jpleau.ca>  Mon, 04 Mar 2019 21:12:53 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: lua-nvim
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Jason Pleau <jason@jpleau.ca>
+Maintainer: Jason Pleau <jason@jpleau.ca>
 Uploaders: James McCoy <jamessan@debian.org>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
             dh-lua,
             libuv1-dev,
             libkvm-dev [kfreebsd-any],
@@ -12,8 +11,9 @@
             lua-luv,
             lua-mpack,
             neovim
-Standards-Version: 4.1.4
+Standards-Version: 4.4.1
 Section: interpreters
+Rules-Requires-Root: no
 Homepage: https://github.com/neovim/lua-client/
 Vcs-Git: https://salsa.debian.org/lua-team/lua-nvim
 Vcs-Browser: https://salsa.debian.org/lua-team/lua-nvim
@@ -41,4 +41,3 @@
 XB-Lua-Versions: ${lua:Versions}
 Description: Lua client for Neovim
  This package provide the static library for lua-nvim
-

## lua-nvim 0.2.1

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,11 @@
-# This Makefile's only purpose is to simplify creating/maintaining a
-# development environment. It will setup a project-private prefix(.deps/usr)
-# with all dependencies required for building/testing
-#
-# local.mk is ignored by git and can be used for developer-specific
-# customizations, which can be:
-# - override default target
-# - define custom targets
-# - override ovariables defined here(all variables are defined with ?=)
+# This Makefile creates a project-private prefix ".deps/usr" with all
+# dependencies required for building/testing.
+
+# local.mk is ignored by git, use it for local build settings.
 -include local.mk
+
+# Use TEST_TAG=foo to pass --tags=foo to busted.
+_TEST_TAG := $(if $(TEST_TAG),--tags=$(TEST_TAG),)
 
 # Dependencies prefix
 DEPS_DIR ?= $(shell pwd)/.deps
@@ -47,7 +45,8 @@
 deps: | $(MPACK) $(COXPCALL) $(BUSTED) $(LUV)
 
 test: all
-	$(BUSTED) -v '--lpath=./nvim/?.lua;' '--cpath=./nvim/?.so;' -o gtest test
+	NVIM_LOG_FILE=nvimlog $(BUSTED) -v $(_TEST_TAG) \
+		'--lpath=./nvim/?.lua;' '--cpath=./nvim/?.so;' -o gtest test
 
 valgrind: all
 	eval $$($(LUAROCKS) path); \

## lua-nvim 0.2.1-1

=== debian/changelog ===
lua-nvim (0.2.1-1-1) unstable; urgency=medium

  * New upstream release
    + Fix 'can receive requests from nvim' test (Closes: #946529)
  * Provide the module for Lua 5.3

 -- James McCoy <jamessan@debian.org>  Sun, 15 Dec 2019 11:33:25 -0500

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
             libuv1-dev,
             libkvm-dev [kfreebsd-any],
             lua-busted,
-            lua-coxpcall,
+# Minimum version for lua5.3 support
+            lua-coxpcall (>> 1.17.0-1~),
             lua-luv,
             lua-mpack,
             neovim

=== debian/rules ===
#!/usr/bin/make -f

export DH_LUA_OPTS="skip-test-app-dynamic skip-test-app-static"

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/.local
	rm -f debian/.nvimlog

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(RC|rc|pre|dev|beta|alpha)/~$1/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/lua-nvim-$1\.tar\.gz/ \
https://github.com/neovim/lua-client/tags .*/v?(\d\S*)\.tar\.gz

## lua-nvim 0.2.2-1

=== debian/changelog ===
lua-nvim (0.2.2-1-1) unstable; urgency=medium

  * New upstream release
  * lintian:
    + Use hardening build flags
    + Use canonical Vcs-Git URL (lua-nvim.git) for Salsa
  * Declare compliance with Policy 4.5.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Tue, 05 May 2020 00:09:09 -0400

=== debian/control ===
--- 
+++ 
@@ -12,11 +12,11 @@
             lua-luv,
             lua-mpack,
             neovim
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Section: interpreters
 Rules-Requires-Root: no
 Homepage: https://github.com/neovim/lua-client/
-Vcs-Git: https://salsa.debian.org/lua-team/lua-nvim
+Vcs-Git: https://salsa.debian.org/lua-team/lua-nvim.git
 Vcs-Browser: https://salsa.debian.org/lua-team/lua-nvim
 
 Package: lua-nvim

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DH_LUA_OPTS="skip-test-app-dynamic skip-test-app-static"
 
 %:

=== debian/tests/control ===
Tests: dh-lua-tests
Restrictions: rw-build-tree, allow-stderr
Depends: @, @builddeps@

## lua-nvim 0.2.3-1

=== debian/changelog ===
lua-nvim (0.2.3-1-1) unstable; urgency=medium

  * New upstream release
  * Set Lua Team as maintainer, move myself to Uploaders
  * Clarify short description of lua-system-dev
  * Declare compliance with Policy 4.6.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Thu, 05 May 2022 18:50:26 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: lua-nvim
 Priority: optional
-Maintainer: Jason Pleau <jason@jpleau.ca>
-Uploaders: James McCoy <jamessan@debian.org>
+Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
 Build-Depends: debhelper-compat (= 12),
             dh-lua,
             libuv1-dev,
@@ -12,7 +12,7 @@
             lua-luv,
             lua-mpack,
             neovim
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Section: interpreters
 Rules-Requires-Root: no
 Homepage: https://github.com/neovim/lua-client/
@@ -40,5 +40,5 @@
          libkvm-dev [kfreebsd-any]
 Provides: ${lua:Provides}
 XB-Lua-Versions: ${lua:Versions}
-Description: Lua client for Neovim
+Description: Lua client for Neovim (development files)
  This package provide the static library for lua-nvim

## lua-nvim 0.2.4-1

=== debian/changelog ===
lua-nvim (0.2.4-1-1) unstable; urgency=medium

  * New upstream release
  * Declare compliance with Policy 4.6.2, no changes needed
  * Use debian/clean to declare required cleanup
  * Annotate neovim Build-Depends as <!nocheck>
  * Remove libkvm-dev Build-Depends now that libuv1-dev has it
  * autopkgtest:
    - Limit autopkgtest runtime to 5 minutes
    - Skip the test if it times out (Closes: #1026869)

 -- James McCoy <jamessan@debian.org>  Fri, 23 Dec 2022 12:49:30 -0500

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,13 @@
 Build-Depends: debhelper-compat (= 12),
             dh-lua,
             libuv1-dev,
-            libkvm-dev [kfreebsd-any],
             lua-busted,
 # Minimum version for lua5.3 support
             lua-coxpcall (>> 1.17.0-1~),
             lua-luv,
             lua-mpack,
-            neovim
-Standards-Version: 4.6.0
+            neovim <!nocheck>,
+Standards-Version: 4.6.2
 Section: interpreters
 Rules-Requires-Root: no
 Homepage: https://github.com/neovim/lua-client/

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,3 @@
 
 %:
 	dh $@ --buildsystem=lua --with lua
-
-override_dh_auto_clean:
-	dh_auto_clean
-	rm -rf debian/.local
-	rm -f debian/.nvimlog
